//*****************************************************************************
//
// Имя файла    : 'dummy.cpp'
// Описание     : Заглушка, драйвер ввода-вывода по умолчанию
// Автор        : Межлумов В.Ш.
//
//*****************************************************************************

#include "io/dummy.h"
#include <string.h>


// ============================================================================
//
///                              Конструктор
//
// ============================================================================

CDrvDummy::CDrvDummy (QObject* parent) :
    CDriver(parent)
{
}


// ============================================================================
///                         Создание нового объекта
// ============================================================================
/// \return     Указатель на созданный объект
// ============================================================================

CDriver* CDrvDummy::NewInstance (void)
{
    return new CDrvDummy( parent() );
}


// ============================================================================
///                     Запрос имени плагина (файла)
// ============================================================================
/// \return     Строка с именем плагина
// ============================================================================

QString CDrvDummy::GetName (void)
{
    return QString("dummy");
}


// ============================================================================
///                     Запрос версии плагина
// ============================================================================
/// \return     Строка с версией
// ============================================================================

QString CDrvDummy::GetVersion (void)
{
    return QString("0.0.1");
}


// ============================================================================
///                     Запрос названия драйвера
// ============================================================================
/// \return     Строка с названием
// ============================================================================

QString CDrvDummy::GetTitle (void)
{
    return QString("Dummy title");
}


// ============================================================================
///                     Запрос описания драйвера
// ============================================================================
/// \return     Строка с описанием
// ============================================================================

QString CDrvDummy::GetDesc ()
{
    return QString("Dummy desc");
}


// ============================================================================
///                     Отрисовка параметров драйвера
// ============================================================================
/// \param  widget      Виджет для отрисовки настроек
/// \param  pSettings   Актульные значения конфигурации
// ============================================================================

void CDrvDummy::DrawSettings (QWidget* widget, QHash<QString, QVariant>* pSettings)
{
    Q_UNUSED(widget);
    Q_UNUSED(pSettings);
}


// ============================================================================
///                     Сохранение выбранных параметров
// ============================================================================
/// \param  widget      Виджет с настройками настроек
/// \param  pSettings   Хранилище настроек
// ============================================================================

void CDrvDummy::SaveSettings (QWidget* widget, QHash<QString, QVariant>* pSettings)
{
    Q_UNUSED(widget);
    Q_UNUSED(pSettings);
}


// ============================================================================
///                     Конфигурирование драйвера
// ============================================================================
/// \param  params  Конфигурационные параметры
/// \return         0 или отрицательный код ошибки
// ============================================================================

int CDrvDummy::Configure (QHash<QString, QVariant>* params)
{
    Q_UNUSED(params);
    return 0;
}


// ============================================================================
///                         Открытие устройства
// ============================================================================
/// \return         0 или отрицательный код ошибки
// ============================================================================

int CDrvDummy::Open (void)
{
    return 0;
}


// ============================================================================
///                         Закрытие устройства
// ============================================================================
/// \return         0 или отрицательный код ошибки
// ============================================================================

int CDrvDummy::Close (void)
{
    return 0;
}


// ============================================================================
///                 Определение состояния устройства
// ============================================================================
/// \return         true - устройство открыто
// ============================================================================

bool CDrvDummy::IsOpen (void)
{
    return false;
}


// ============================================================================
///                         Отправка данных
// ============================================================================
/// \param  data    Данные для записи
/// \param  size    Количество данных
// ============================================================================

void CDrvDummy::Send (const char* data, uint size)
{
    emit Sended(data, size);
}
